package com.loganmagnan.blockhealth.managers;

import com.loganmagnan.blockhealth.playerdata.PlayerData;
import com.loganmagnan.blockhealth.BlockHealth;
import com.loganmagnan.blockhealth.playerdata.PlayerState;
import lombok.Getter;

import java.util.*;

public class PlayerDataManager {

	private BlockHealth plugin = BlockHealth.getInstance();

	@Getter private Map<UUID, PlayerData> players = new HashMap<>();

	public PlayerData getOrCreate(UUID uniqueId) {
		return this.players.computeIfAbsent(uniqueId, PlayerData::new);
	}

	public PlayerData getPlayerData(UUID uniqueId) {
		return this.players.getOrDefault(uniqueId, new PlayerData(uniqueId));
	}

	public Collection<PlayerData> getAllPlayers() {
		return this.players.values();
	}

	public void loadPlayerData(PlayerData playerData) {
		playerData.setPlayerState(PlayerState.SPAWN);
		playerData.setLoaded(true);
	}
}
