package com.loganmagnan.blockhealth.playerdata;

import com.loganmagnan.blockhealth.BlockHealth;
import com.loganmagnan.blockhealth.managers.PlayerDataManager;
import com.loganmagnan.blockhealth.playerdata.currentgame.PlayerCurrentGameData;
import lombok.Getter;
import lombok.Setter;

import java.util.UUID;

@Getter
@Setter
public class PlayerData {

    private PlayerDataManager playerDataManager = BlockHealth.getInstance().getPlayerDataManager();
    private PlayerState playerState = PlayerState.SPAWN;

    private PlayerSettings playerSettings = new PlayerSettings();
    private PlayerCurrentGameData currentGameData = new PlayerCurrentGameData();

    private UUID uniqueId;
    private boolean loaded;

    public PlayerData(UUID uniqueId) {
        this.uniqueId = uniqueId;
        this.loaded = false;
        this.playerDataManager.loadPlayerData(this);
    }

    public boolean isInSpawn() {
        return this.playerState == PlayerState.SPAWN;
    }
}
