package com.loganmagnan.blockhealth.runnables;

import lombok.Getter;
import lombok.Setter;
import com.loganmagnan.blockhealth.BlockHealth;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class BlockHealthRunnable implements Runnable {

    private BlockHealth main = BlockHealth.getInstance();

    private List<Player> players = new ArrayList<Player>();

    private int taskId;

    public BlockHealthRunnable() {
        for (Player player : this.main.getServer().getOnlinePlayers()) {
            this.players.add(player);
        }

        this.taskId = this.main.getServer().getScheduler().scheduleSyncRepeatingTask(this.main, this, 2L, 2L);
    }

    @Override
    public void run() {
        for (Player player : this.players) {
            Block block = player.getTargetBlock(5);

            if (block == null) {
                continue;
            }

            if (block.getType() == Material.AIR) {
                continue;
            }

            this.main.getBlockManager().sendPlayerBlockHealthMessage(player, block);
        }
    }
}
